/*
 * hc_12.c
 *
 *  Created on: Jun 10, 2023
 *      Author: hussamaldean
 */

#include "hc_12.h"
#include "hc_12_uart.h"
#include "stdio.h"
#include "stm32f4xx.h"
#include "led.h"



unsigned char at_data[40];

volatile unsigned char uart1_rec;

void HC_12_SET_Pin_init(void)
{
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOAEN;

	GPIOA->MODER|= GPIO_MODER_MODE0_0;

	GPIOA->MODER&= ~GPIO_MODER_MODE0_1;

	GPIOA->BSRR = GPIO_BSRR_BS0;

}


void HC_12_Config(HC_12_Config_Typedef *config)
{
	GPIOA->BSRR = GPIO_BSRR_BR0;

	sprintf(at_data,"AT+B%d\r\n",config->Buadrate);
	hc12_write_at_command(at_data);

	if (config->Channel >127)
	{
		config->Channel=127;
	}

	if (config->Channel==0)
	{
		config->Channel=1;
	}

	sprintf(at_data,"AT+C%d\r\n",config->Channel);
	hc12_write_at_command(at_data);

	sprintf(at_data,"AT+P%d\r\n",config->Power);
	hc12_write_at_command(at_data);

	GPIOA->BSRR = GPIO_BSRR_BS0;

}


void HC_12_Callback(unsigned char ch)
{
	if (ch == '1')
	{
		led_toggle();
	}
}

void USART1_IRQHandler (void)
{

	if(USART1->SR & USART_SR_RXNE){
	uart1_rec=USART1->DR;
	HC_12_Callback(uart1_rec);

	USART1->SR &= ~USART_SR_RXNE;}


}
